
// Based on interface defined in Ethernet's Client.h

#ifndef __RNXV_CLIENT_H__
#define __RNXV_CLIENT_H__

#include "Print.h"

#include "RNXVParsedStream.h"

#include "RNXVDevice.h"

class RNXVClient : public Print {
 public:
  RNXVClient(uint8_t *ip, uint16_t port, RNXVDevice& device);
  RNXVClient(const char* domain, uint16_t port, RNXVDevice& device);

  boolean connect();

  size_t write(byte value);
  size_t write(const char *str);
  size_t write(const uint8_t *buffer, size_t size);

  int available();
  int read();
  void flush(void);

  bool connected();
  void stop();
  boolean reset();

  operator bool();
  
  RNXVDevice& device() { return _RNXV; }

 private:
  RNXVDevice& _RNXV;

  uint8_t *_ip;
  uint16_t _port;

  const char *_domain;

  bool isOpen;

  RNXVParsedStream stream;

};

#endif
