#ifndef __RNXV_DEVICE_H__
#define __RNXV_DEVICE_H__

#include "Arduino.h"

#define DEFAULT_SERVER_PORT 80

#define RNXV_BAUD		100

class RNXVDevice {
  public:
    RNXVDevice(Stream& SerialPort);
    void begin();

    boolean join(const char *ssid);
    boolean join(const char *ssid, const char *passphrase, 
                 boolean isWPA = true);

    boolean configure(byte option, unsigned long value);

    const char * ip();
    
    Stream& port() { return serialPort; }
    
  private:
    Stream& serialPort;

    void attemptSwitchToCommandMode();
    void switchToCommandMode();
    void setConfiguration();
    boolean sendCommand(const char *command,
                        boolean isMultipartCommand, // Has default value
                        const char *expectedResponse); // Has default value
    void waitForResponse(const char *toMatch);
    void skipRemainderOfResponse();
    boolean responseMatched(const char *toMatch);

    boolean findInResponse(const char *toMatch, unsigned int timeOut);
    boolean enterCommandMode(boolean isAfterBoot = false);
    boolean reboot(boolean isAfterBoot = true);
    
    friend class RNXVClient;
};

#endif
