
// Based on ring buffer implementation in `HardwareSerial`.
// TODO: Do proper license stuff

#ifndef __RNXV_PARSED_STREAM_H__
#define __RNXV_PARSED_STREAM_H__

#define RX_BUFFER_SIZE 64

#include <string.h>

#include "Stream.h"

struct ring_buffer {
  unsigned char buffer[RX_BUFFER_SIZE];
  int head;
  int tail;
};

const static char *MATCH_TOKEN = "*CLOS*";

class RNXVParsedStream {
private:  
  ring_buffer _rx_buffer;

  void getByte();
  void storeByte(unsigned char c);

  unsigned int bytes_matched;

  uint8_t available(bool raw);

  int freeSpace();

  bool _closed;


public:
  Stream& serialPort;
  RNXVParsedStream(Stream& stream);
  uint8_t available(void);
  int read(void);

  bool closed();

  void reset();
};


#endif
